﻿@page "/tareas"

@using BlazorCrud.Shared;
@using CurrieTechnologies.Razor.SweetAlert2;
@using BlazorCrud.Client.Services;

@inject SweetAlertService Swal;
@inject ITareaService TareaService

<h3>Tareas</h3>

<a class="btn btn-success btn-sm mb-3" href="tarea">Nueva Tarea</a>

<table class="table">
    <thead>
        <tr>
            <th>Nombre</th>
            <th>Fecha</th>
            <th>Estado</th>
            <th>Activa</th>
        </tr>
    </thead>
    <tbody>

        @if (listaTarea == null)
        {

            <tr>
                <td colspan="4" align="center">
                    <img style="width:50px" src="https://media.tenor.com/On7kvXhzml4AAAAj/loading-gif.gif" />
                </td>
            </tr>
        }
        else
        {
            @foreach (var item in listaTarea)
            {
                <tr>
                    <td>@item.Nombre</td>
                    <td>@item.Fecha.ToString("dd/MM/yyyy")</td>
                    <td>@item.Estado</td>
                    <td>@item.Activa</td>

                    <td>
                        <a class="btn btn-primary btn-sm" href="tarea/@item.Id">
                            <i class="oi oi-pencil"></i>
                        </a>
                        <button type="button" class="btn btn-danger btn-sm ms-2" @onclick="(() => Eliminar(item.Id))">
                            <i class="oi oi-trash"></i>
                        </button>

                    </td>
                </tr>
            }
        }



    </tbody>
</table>


@code {
    List<TareaDTO>? listaTarea = null;


    protected override async Task OnInitializedAsync()
    {
        listaTarea = await TareaService.Lista();
    }

    private async Task Eliminar(int id)
    {
        var resultado = await Swal.FireAsync(new SweetAlertOptions
            {
                Title = "Eliminar Tarea",
                Text = "Deseas eliminar esta Tarea",
                Icon = SweetAlertIcon.Question,
                ShowCancelButton = true
            });

        if (resultado.IsConfirmed)
        {
            var eliminado = await TareaService.Eliminar(id);

            if (eliminado)
                listaTarea = listaTarea!.FindAll(e => e.Id != id);

        }


    }

}
